



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android WebView使用深入浅出</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android WebView使用深入浅出</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:09:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>目前很多android app都内置了可以显示web页面的界面，会发现这个界面一般都是由一个叫做WebView的组件渲染出来的，学习该组件可以为你的app开发提升扩展性。</p>
<p>先说下WebView的一些优点：</p>
<ul><li>可以直接显示和渲染web页面，直接显示网页</li>
<li>webview可以直接用html文件（网络上或本地assets中）作布局</li>
<li>和JavaScript交互调用</li></ul>
<p><strong>一、基本使用</strong></p>
<p>首先layout中即为一个基本的简单控件：</p>
<div>
<pre class="prettyprint linenums">&lt;WebView<br />
        android:id="@+id/webView1"<br />
        android:layout_width="fill_parent"<br />
        android:layout_height="fill_parent"<br />
        android:layout_marginTop="10dp" /&gt;</pre>
</div>
<p>同时，因为要房访问网络，所以manifest中必须要加uses-permission：</p>
<div>
<pre class="prettyprint linenums">&lt;uses-permission android:name="android.permission.INTERNET"/&gt;</pre>
</div>
<p>在activity中即可获得webview的引用，同时load一个网址：</p>
<div>
<pre class="prettyprint linenums">webview = (WebView) findViewById(R.id.webView1);<br />
webview.loadUrl("http://www.baidu.com/");<br />//webview.reload();// reload page</pre>
</div>
<p>这个时候发现一个问题，启动应用后，自动的打开了系统内置的浏览器，解决这个问题需要为webview设置&nbsp;WebViewClient，并重写方法：</p>
<div>
<pre class="prettyprint linenums">webview.setWebViewClient(new WebViewClient(){<br />
            @Override<br />
            public boolean shouldOverrideUrlLoading(WebView view, String url) {<br />
                view.loadUrl(url);<br />
                return true;<br />
            }<br />
        });</pre>
</div>
<p>若自己定义了一个页面加载进度的progressbar，需要展示给用户的时候，可以通过如下方式获取webview内页面的加载进度：</p>
<div>
<pre class="prettyprint linenums">webview.setWebChromeClient(new WebChromeClient(){<br />
            @Override<br />
            public void onProgressChanged(WebView view, int newProgress) {<br />
                //get the newProgress and refresh progress bar<br />
            }<br />
        });</pre>
</div>
<p>每个页面，都有一个标题，比如www.baidu.com这个页面的title即&ldquo;百度一下，你就知道&rdquo;，那么如何知道当前webview正在加载的页面的title呢：</p>
<div>
<pre class="prettyprint linenums">webview.setWebChromeClient(new WebChromeClient(){<br />
            @Override<br />
            public void onReceivedTitle(WebView view, String title) {<br />
                titleview.setText(title);//a textview<br />
            }<br />
        });</pre>
</div>
<p><strong>二、通过webview控件下载文件</strong></p>
<p>通常webview渲染的界面中含有可以下载文件的链接，点击该链接后，应该开始执行下载的操作并保存文件到本地中。webview来下载页面中的文件通常有两种方式：</p>
<p>1. 自己通过一个线程写java io的代码来下载和保存文件（可控性好）</p>
<p>2. 调用系统download的模块（代码简单）</p>
<p>方法一：</p>
<p>首先要写一个下载并保存文件的线程类</p>
<div>
<pre class="prettyprint linenums">public class HttpThread extends Thread {

    private String mUrl;

    public HttpThread(String mUrl) {<br />
        this.mUrl = mUrl;<br />
    }

    @Override<br />
    public void run() {<br />
        URL url;<br />
        try {<br />
            url = new URL(mUrl);<br />
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();<br />
            conn.setDoInput(true);<br />
            conn.setDoOutput(true);<br />
            InputStream in = conn.getInputStream();

            File downloadFile;<br />
            File sdFile;<br />
            FileOutputStream out = null;<br />
            if(Environment.getExternalStorageState().equals(Environment.MEDIA_UNMOUNTED)){<br />
                downloadFile = Environment.getExternalStorageDirectory();<br />
                sdFile = new File(downloadFile, "test.file");<br />
                out = new FileOutputStream(sdFile);<br />
            }

            //buffer 4k<br />
            byte[] buffer = new byte[1024 * 4];<br />
            int len = 0;<br />
            while((len = in.read(buffer)) != -1){<br />
                if(out != null)<br />
                    out.write(buffer, 0, len);<br />
            }

            //close resource<br />
            if(out != null)<br />
                out.close();

            if(in != null){<br />
                in.close();<br />
            }

        } catch (IOException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        }<br />
    }

}</pre>
</div>
<p>随后要实现一个DownloadListener接口，这个接口实现方法OnDownloadStart()，当用户点击一个可以下载的链接时，该回调方法被调用同时传进来该链接的URL，随后即可以对该URL塞入HttpThread进行下载操作：</p>
<div>
<pre class="prettyprint linenums">//创建DownloadListener (webkit包)<br />
class MyDownloadListenter implements DownloadListener{

        @Override<br />
        public void onDownloadStart(String url, String userAgent,<br />
                String contentDisposition, String mimetype, long contentLength) {<br />
            System.out.println("url ==== &gt;" + url);<br />
            new HttpThread(url).start();<br />
        }

    }

//给webview加入监听<br />
webview.setDownloadListener(new MyDownloadListenter());</pre>
</div>
<p>方法二：</p>
<p>直接发送一个action_view的intent即可：</p>
<div>
<pre class="prettyprint linenums">class MyDownloadListenter implements DownloadListener{

        @Override<br />
        public void onDownloadStart(String url, String userAgent,<br />
                String contentDisposition, String mimetype, long contentLength) {<br />
            System.out.println("url ==== &gt;" + url);<br />
            //new HttpThread(url).start();

            Uri uri = Uri.parse(url);<br />
            Intent intent = new Intent(Intent.ACTION_VIEW, uri);<br />
            startActivity(intent);<br />
        }

    }</pre>
</div>
<p><strong>三、错误处理</strong></p>
<p>当我们使用浏览器的时候，通常因为加载的页面的服务器的各种原因导致各种出错的情况，最平常的比如404错误，通常情况下浏览器会提示一个错误提示页面。事实上这个错误提示页面是浏览器在加载了本地的一个页面，用来提示用户目前已经出错了。</p>
<p>但是当我们的app里面使用webview控件的时候遇到了诸如404这类的错误的时候，若也显示浏览器里面的那种错误提示页面就显得很丑陋了，那么这个时候我们的app就需要加载一个本地的错误提示页面，即webview如何加载一个本地的页面。</p>
<p>1. 首先我们需要些一个html文件，比如error_handle.html，这个文件里面就是当出错的时候需要展示给用户看的一个错误提示页面，尽量做的精美一些。然后将该文件放置到代码根目录的assets文件夹下。</p>
<p>2. 随后我们需要复写WebViewClient的onRecievedError方法，该方法传回了错误码，根据错误类型可以进行不同的错误分类处理</p>
<div>
<pre class="prettyprint linenums">webview.setWebViewClient(new WebViewClient(){

            @Override<br />
            public void onReceivedError(WebView view, int errorCode,<br />
                    String description, String failingUrl) {<br />
                switch(errorCode)<br />
                {<br />
                case HttpStatus.SC_NOT_FOUND:<br />
                    view.loadUrl("file:///android_assets/error_handle.html");<br />
                    break;<br />
                }<br />
            }<br />
        });</pre>
</div>
<p>其实，当出错的时候，我们可以选择隐藏掉webview，而显示native的错误处理控件，这个时候只需要在onReceivedError里面显示出错误处理的native控件同时隐藏掉webview即可。</p>
<p><strong>四、webview同步cookies</strong></p>
<p>cookies是服务器用来保存每个客户的常用信息的，下次客户进入一个诸如登陆的页面时服务器会检测cookie信息，如果通过则直接进入登陆后的页面。</p>
<p>在webview中，如果之前已经登陆过了，那么下次再进入同样的登陆界面时，若需要再次登陆的话，一定会很恼人，所以这里提供一个webview同步cookies的方法。</p>
<p>1.首先，我们假设某个网站的登陆界面需要提供两个参数，一个是name，一个是pwd，那么要是对这个页面进行登陆，那么必须给与这两个信息。我们假设服务器已经注册了name为jason，pwd为123456这个账号。</p>
<p>2.下面，写一个Thread用来将name和pwd自动的登入，在服务器返回的response中获得cookie信息，稍后对这个cookie进行保存，这里先给出这个Thread的代码：</p>
<div>
<pre class="prettyprint linenums">public class HttpCookie extends Thread {

    private Handler mHandler;

    public HttpCookie(Handler mHandler) {<br />
        this.mHandler = mHandler;<br />
    }

    @Override<br />
    public void run() {<br />
        HttpClient client = new DefaultHttpClient();<br />
        HttpPost post = new HttpPost("");//this place should add the login address

        List&lt;NameValuePair&gt; list = new ArrayList&lt;NameValuePair&gt;();<br />
        list.add(new BasicNameValuePair("name", "jason"));<br />
        list.add(new BasicNameValuePair("pwd", "123456"));

        try {<br />
            post.setEntity(new UrlEncodedFormEntity(list));<br />
            HttpResponse reponse = client.execute(post);<br />
            if(reponse.getStatusLine().getStatusCode() == HttpStatus.SC_OK){<br />
                AbstractHttpClient absClient = (AbstractHttpClient) client;<br />
                List&lt;Cookie&gt; cookies = absClient.getCookieStore().getCookies();

                for(Cookie cookie:cookies){<br />
                    if(cookie != null){<br />
                        //TODO<br />
                        //this place would get the cookies<br />
                    }<br />
                }<br />
            }

        } catch (UnsupportedEncodingException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        } catch (ClientProtocolException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        } catch (IOException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        }<br />
    }

}</pre>
</div>
<p>由于这是一个子线程，所以需要在主线程中创建并执行。</p>
<p>同时，因为其实子线程，那么里面必须含有一个handler的元素，用来当成功获取cookie后通知主线程进行同步和保存。初始化这个子线程的时候需要将主线程上的handler给传过来，随后在以上代码的TODO中发送消息，让主线程记录cookie，发送的这个消息需要将cookie信息包含进去：</p>
<div>
<pre class="prettyprint linenums">if(cookie != null){<br />
    //TODO<br />
    //this place would get the cookies<br />
    Message msg = new Message();<br />
    msg.obj = cookie;<br />
    if(mHandler != null){<br />
        mHandler.sendMessage(msg);<br />
        return;<br />
    }<br />
}</pre>
</div>
<p>随后在主线程中（webview加载登陆界面前），在handler中将会获取到cookie信息，下面将对该cookie进行保存和同步：</p>
<div>
<pre class="prettyprint linenums">    private Handler mHandler = new Handler(){<br />
        public void handleMessage(android.os.Message msg)<br />
        {

            CookieSyncManager.createInstance(MainActivity.this);<br />
            CookieManager cookieMgr = CookieManager.getInstance();<br />
            cookieMgr.setAcceptCookie(true);<br />
            cookieMgr.setCookie("", msg.obj.toString());// this place should add the login host address(not the login index address)<br />
            CookieSyncManager.getInstance().sync();

            webview.loadUrl("");// login index address<br />
        };<br />
    };</pre>
</div>
<p>这个时候发现webview加载的login index页面中可以自动的登陆了并显示登陆后的界面。</p>
<p><strong>五、&nbsp;WebView与JavaScript的交互</strong></p>
<p>1. webview调用js</p>
<div>
<pre class="prettyprint linenums">mWebView.loadUrl("javascript:do()");</pre>
</div>
<p>以上是webview在调用js中的一个叫做do的方法，该js所在的html文件大致如下：</p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
    &lt;script language="javascript"&gt;<br />
        /* This function is invoked by the webview*/<br />
        function do() {<br />
            alert("1");<br />
        }<br />
    &lt;/script&gt;<br />
    &lt;body&gt;<br />
        &lt;a onClick="window.demo.clickOnAndroid()"&gt;&lt;div style="width:80px;<br />
            margin:0px auto;<br />
            padding:10px;<br />
            text-align:center;<br />
            border:2px solid #111111;" &gt;<br />
                &lt;img id="droid" src="xx.png"/&gt;&lt;br&gt;<br />
                Click me!<br />
        &lt;/div&gt;&lt;/a&gt;<br />
    &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>2. js调用webview</p>
<p>我们假设下列的本地类是要给js调用的：</p>
<div>
<pre class="prettyprint linenums">package com.test.webview;<br />class DemoJavaScriptInterface {

        DemoJavaScriptInterface() {<br />
        }

        /**<br />
         * This is not called on the UI thread. Post a runnable to invoke<br />
         * loadUrl on the UI thread.<br />
         */<br />
        public void clickOnAndroid() {<br />
            mHandler.post(new Runnable() {<br />
                public void run() {<br />
                    //TODO<br />
                }<br />
            });

        }<br />
    }</pre>
</div>
<p>首先给webview设置：</p>
<div>
<pre class="prettyprint linenums">mWebview.setJavaScriptEnabled(true);</pre>
</div>
<p>随后将本地的类（被js调用的）映射出去：</p>
<div>
<pre class="prettyprint linenums">mWebView.addJavascriptInterface(new DemoJavaScriptInterface(), "demo");</pre>
</div>
<p>&ldquo;demo&rdquo;这个名字就是公布出去给JS调用的，那么js久可以直接用下列代码调用本地的DemoJavaScriptInterface类中的方法了：</p>
<div>
<pre class="prettyprint linenums">&lt;body onload="javascript:demo.clickOnAndroid()"&gt;<br />
    ...<br />
&lt;/body&gt;</pre>
</div>
<p><strong>六、WebView与JavaScript相互调用混淆问题</strong></p>
<p>若webview中的js调用了本地的方法，正常情况下发布的debug包js调用的时候是没有问题的，但是通常发布商业版本的apk都是要经过混淆的步骤，这个时候会发现之前调用正常的js却无法正常调用本地方法了。</p>
<p>这是因为混淆的时候已经把本地的代码的引用给打乱了，导致js中的代码找不到本地的方法的地址。</p>
<p>解决这个问题很简单，即在proguard.cfg文件中加上一些代码，声明本地中被js调用的代码不被混淆。下面举例说明：</p>
<p>第五节中被js调用的那个类DemoJavaScriptInterface的包名为com.test.webview，那么就要在proguard.cfg文件中加入：</p>
<div>
<pre class="prettyprint linenums">-keep public class com.test.webview.DemoJavaScriptInterface{<br />
    public &lt;methods&gt;;<br />
}</pre>
</div>
<p>若是内部类，则大致写成如下形式：</p>
<div>
<pre class="prettyprint linenums">-keep public class com.test.webview.DemoJavaScriptInterface$InnerClass{<br />
    public &lt;methods&gt;;<br />
}</pre>
</div>
<p>若android版本比较新，可能还需要添加上下列代码：</p>
<div>
<pre class="prettyprint linenums">-keepattributes *Annotation*<br />
-keepattributes *JavascriptInterface*</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o1zo1q.html">C&num;开发微信门户及应用&lpar;29&rpar;--微信个性化菜单的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jvow8.html">Linux 架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlndex8.html">hibernate配置文件详细解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzjz6q.html">Linux运维人员共用root帐户权限审计</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd1no7q.html">【HDU】4336 Card Collector</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4zg3q.html">微信分享jsdk接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjj0m28.html">HDU 1677&Tab;Nested Dolls</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m2vxm8.html">&lbrack;ios2&rsqb;发布时去除NSLog打印</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1vm2xq.html">mybatis 关联关系查询 java</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p6w08.html">HDU 2612&Tab;Find a way BFS，防止超时是关键</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgg7g9.html">酷睿彩票合买代购网站管理系统 v2016 - 源码下载 有合买功能 有免费版 标准版 高级版</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgknem8.html">&lbrack;js插件开发教程&rsqb;实现一个比较完整的开源级选项卡插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4k619.html">button JS篇ant Design of react</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyyejv9.html">Python find函数用法和概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1vg6xq.html">vue中v-show与v-if的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15jveq.html">MinGW GCC 7&period;2&period;0 2017年8月份出炉啦</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdeywe9.html">yum -y 与yum有何区别&lpar;转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xxv2q.html">【BI学习笔记】在Linux上安装Wyn Enterprise商业智能报表服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ow23k8.html">luogu P3707 &lbrack;SDOI2017&rsqb;相关分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vexz6q.html">【python】列出http&colon;&sol;&sol;www&period;cnblogs&period;com&sol;xiandedanteng中所有博文的标题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4952ew69.html">Java递归实现操作系统文件的复制、粘贴和删除功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/390631o9.html">OS X下安装Redis及配置开机启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7kr1x9.html">ASP&period;NET5 MVC6入门教学之一（自己动手）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93mmkz8.html">&lpar;二&rpar;我的Makefile学习冲动&amp;amp&semi;&amp;amp&semi;编译过程概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnp7g28.html">TCP连接与关闭</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z0d6nq.html">Python的逻辑运算符and小析</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv4glyq.html">边工作边刷题：70天一遍leetcode&colon; day 84-2</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jwjj48.html">codeforces 724</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4rg1n8.html">2014 Super Training &num;4 G What day is that day&quest; --两种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn7mog8.html">SGU 174 Walls</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
